## org.h2.expression
Class Operation

    java.lang.Object
      org.h2.expression.Expression
          org.h2.expression.Operation

    public class Operation

extends Expression

A mathematical expression, or string concatenation.

Field Summary
`static int` `CONCAT` This operation represents a string concatenation as in 'Hello' || 'World'.
`static int` `DIVIDE` This operation represents a division as in 4 * 2.
`static int` `MINUS` This operation represents a subtraction as in 2 - 1.
`static int` `MULTIPLY` This operation represents a multiplication as in 2 * 3.
`static int` `NEGATE` This operation represents a negation as in - ID.
`static int` `PLUS` This operation represents an addition as in 1 + 2.

Constructor Summary
`Operation(int opType, Expression left, Expression right)`

Method Summary
`int` `getCost()` Estimate the cost to process the expression.
`int` `getDisplaySize()` Get the display size of this expression.
`long` `getPrecision()` Get the precision of this expression.
`int` `getScale()` Get the scale of this expression.
`java.lang.String` `getSQL()` Get the SQL statement of this expression.
`int` `getType()` Return the data type.
`Value` `getValue(Session session)` Return the resulting value for the current row.
`boolean` `isEverything(ExpressionVisitor visitor)` Check if this expression and all sub-expressions can fulfill a criteria.
`void` `mapColumns(ColumnResolver resolver, int level)` Map the columns of the resolver to expression columns.
`Expression` `optimize(Session session)` Try to optimize the expression.
`void` `setEvaluatable(TableFilter tableFilter, boolean b)` Tell the expression columns whether the table filter can return values now.
`void` `updateAggregate(Session session)` Update an aggregate value.

Methods inherited from class org.h2.expression.Expression
`addFilterConditions, createIndexConditions, getAlias, getBooleanValue, getColumnName, getNonAliasExpression, getNotIfPossible, getNullable, getSchemaName, getTableAlias, getTableName, isAutoIncrement, isConstant, isEverything, isValueSet, isWildcard, optimizeInJoin, toString`

Methods inherited from class java.lang.Object
`clone, equals, finalize, getClass, hashCode, notify, notifyAll, wait, wait, wait`

Field Detail

### CONCAT

    public static final int CONCAT

  This operation represents a string concatenation as in 'Hello' || 'World'.

  See Also:
    Constant Field Values

### PLUS

    public static final int PLUS

  This operation represents an addition as in 1 + 2.

  See Also:
    Constant Field Values

### MINUS

    public static final int MINUS

  This operation represents a subtraction as in 2 - 1.

  See Also:
    Constant Field Values

### MULTIPLY

    public static final int MULTIPLY

  This operation represents a multiplication as in 2 * 3.

  See Also:
    Constant Field Values

### DIVIDE

    public static final int DIVIDE

  This operation represents a division as in 4 * 2.

  See Also:
    Constant Field Values

### NEGATE

    public static final int NEGATE

  This operation represents a negation as in - ID.

  See Also:
    Constant Field Values

Constructor Detail

### Operation

    public Operation(int opType,
                     Expression left,
                     Expression right)

Method Detail

### getSQL

    public java.lang.String getSQL()

  Description copied from class: `Expression`
  Get the SQL statement of this expression. This may not always be the original SQL statement, specially after optimization.

  Specified by:
    `getSQL` in class `Expression`
  Returns:
    the SQL statement

### getValue

    public Value getValue(Session session)
                   throws java.sql.SQLException

  Description copied from class: `Expression`
  Return the resulting value for the current row.

  Specified by:
    `getValue` in class `Expression`
  Parameters:
    `session` - the session
  Returns:
    the result
  Throws:
    `java.sql.SQLException`

### mapColumns

    public void mapColumns(ColumnResolver resolver,
                           int level)
                    throws java.sql.SQLException

  Description copied from class: `Expression`
  Map the columns of the resolver to expression columns.

  Specified by:
    `mapColumns` in class `Expression`
  Parameters:
    `resolver` - the column resolver
    `level` - the subquery nesting level
  Throws:
    `java.sql.SQLException`

### optimize

    public Expression optimize(Session session)
                        throws java.sql.SQLException

  Description copied from class: `Expression`
  Try to optimize the expression.

  Specified by:
    `optimize` in class `Expression`
  Parameters:
    `session` - the session
  Returns:
    the optimized expression
  Throws:
    `java.sql.SQLException`

### setEvaluatable

    public void setEvaluatable(TableFilter tableFilter,
                               boolean b)

  Description copied from class: `Expression`
  Tell the expression columns whether the table filter can return values now. This is used when optimizing the query.

  Specified by:
    `setEvaluatable` in class `Expression`
  Parameters:
    `tableFilter` - the table filter
    `b` - true if the table filter can return value

### getType

    public int getType()

  Description copied from class: `Expression`
  Return the data type. The data type may not be known before the optimization phase.

  Specified by:
    `getType` in class `Expression`
  Returns:
    the type

### getPrecision

    public long getPrecision()

  Description copied from class: `Expression`
  Get the precision of this expression.

  Specified by:
    `getPrecision` in class `Expression`
  Returns:
    the precision

### getDisplaySize

    public int getDisplaySize()

  Description copied from class: `Expression`
  Get the display size of this expression.

  Specified by:
    `getDisplaySize` in class `Expression`
  Returns:
    the display size

### getScale

    public int getScale()

  Description copied from class: `Expression`
  Get the scale of this expression.

  Specified by:
    `getScale` in class `Expression`
  Returns:
    the scale

### updateAggregate

    public void updateAggregate(Session session)
                         throws java.sql.SQLException

  Description copied from class: `Expression`
  Update an aggregate value. This method is called at statement execution time. It is usually called once for each row, but if the expression is used multiple times (for example in the column list, and as part of the HAVING expression) it is called multiple times - the row counter needs to be used to make sure the internal state is only updated once.

  Specified by:
    `updateAggregate` in class `Expression`
  Parameters:
    `session` - the session
  Throws:
    `java.sql.SQLException`

### isEverything

    public boolean isEverything(ExpressionVisitor visitor)

  Description copied from class: `Expression`
  Check if this expression and all sub-expressions can fulfill a criteria. If any part returns false, the result is false.

  Specified by:
    `isEverything` in class `Expression`
  Parameters:
    `visitor` - the visitor
  Returns:
    if the criteria can be fulfilled

### getCost

    public int getCost()

  Description copied from class: `Expression`
  Estimate the cost to process the expression. Used when optimizing the query, to calculate the query plan with the lowest estimated cost.

  Specified by:
    `getCost` in class `Expression`
  Returns:
    the estimated cost